/*
 * bltInit.c --
 *
 * Copyright 1993-1994 by AT&T Bell Laboratories.
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that the copyright notice and warranty
 * disclaimer appear in supporting documentation, and that the
 * names of AT&T Bell Laboratories any of their entities not be used
 * in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * AT&T disclaims all warranties with regard to this software, including
 * all implied warranties of merchantability and fitness.  In no event
 * shall AT&T be liable for any special, indirect or consequential
 * damages or any damages whatsoever resulting from loss of use, data
 * or profits, whether in an action of contract, negligence or other
 * tortuous action, arising out of or in connection with the use or
 * performance of this software.
 *
 */

#include <tcl.h>

#ifndef BLT_VERSION
#define BLT_VERSION "1.9"
#endif

/*
 * The inclusion of contributed commands/widgets can be suppressed by
 * defining the respective preprocessor symbol.
 */
#ifdef STk_CODE
#include <stk.h>
#ifndef USE_TK
#  define USE_TK
#endif
#endif

extern int Blt_HtextInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_GraphInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_BarchartInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_TableInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_BusyInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_WindowInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_BitmapInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_DragDropInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_BellInit _ANSI_ARGS_((Tcl_Interp *interp));
extern int Blt_CutbufferInit _ANSI_ARGS_((Tcl_Interp *interp));

PRIMITIVE STk_init_blt(void)
{
  extern Tcl_Interp *STk_main_interp;

    if (Blt_HtextInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    if (Blt_GraphInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    if (Blt_BarchartInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    if (Blt_TableInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    if (Blt_BusyInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    if (Blt_WindowInit(STk_main_interp) != TCL_OK) {
	return TCL_ERROR;
    }
    if (Blt_DragDropInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    if (Blt_BellInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    if (Blt_CutbufferInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    if (Blt_BitmapInit(STk_main_interp) != TCL_OK) {
	goto Error;
    }
    return UNDEFINED;
Error:
    STk_err("BLT initialization error.", NIL);
}
